/*
  Пример линейной аппроксимации методом наименьших квадратов
  Два массива: по оси Х и по оси У
  Линейная аппроксимация повозоляет получить уравнение прямой,
  равноудалённой от точек на плоскости ХУ. Удобно для расчёта
  роста изменяющейся шумящей величины. Уравнение вида у = A*x + B
  В папке с данным примером есть скриншот из excel,
  иллюстрирующий работу аппроксимации с такими же исходными
*/

// два массива с данными (одинаковой размероности и размера)
int x_array[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
int y_array[] = {1, 5, 2, 8, 3, 9, 10, 5, 15, 12};

#include <GyverFilters.h>
GLinear<int> test;    // указываем тип данных в <>

void setup() {
  Serial.begin(9600);

  // передаём массивы и размер одного из них
  test.compute((int*)x_array, (int*)y_array, 10);

  // Уравнение вида у = A*x + B
  Serial.println(test.getA());  // получить коэффициент А
  Serial.println(test.getB());  // получить коэффициент В
  Serial.println(test.getDelta());  // получить изменение (аппроксимированное)
}

void loop() {

}
